

import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.util.Hashtable;

import javax.microedition.io.Connector;

import com.nttdocomo.ui.IApplication;
import com.nttdocomo.io.HttpConnection;

import generated.client.CustomTypes;

/**
 * This class is MIDP client.
 */

public class CliantApplicationDoja extends IApplication {

    private static String persistenceUrl = "http://localhost:8080/project/servlet/InventoryObjectServlet";
	private static HttpConnection conn = null;
	private static DataInputStream dis = null;
	static private DataOutputStream dos = null;
    	
    public void start() {
    	loadData();
    	
		Hashtable h = new Hashtable();
		for (short i = 0; i < 6; i++) {
			Hashtable nh = new Hashtable();
			nh.put("type", "InventoryObject");
			nh.put("idinv", new Short(i));
			nh.put("valueinv", new Short(i));
			h.put("" + i, nh);
		}
		uploadData(h);
    }
    
	public static void loadData() throws Exception {
		
		try {
			// ouverture de la connexion avec le serveur
			String url = persistenceUrl + "?type=select";
			conn = (HttpConnection) Connector.open(url, Connector.READ, true);
			conn.setRequestMethod(HttpConnection.GET);
			
			// connexion
			conn.connect();
			// chargement des donnes
			dis = conn.openDataInputStream();
			
			Hashtable data = CustomTypes.decodeData(dis);
			for (short i = 0; i < 6; i++) {
				Hashtable nh = (Hashtable)data.get(""+i);
				System.out.println("data i: "+i + " nh: "+nh);
				Short idinv = (Short)nh.get("idinv");
				Short valueinv = (Short)nh.get("valueinv");
				// Put here the Retrieved data treatment
				// Here just a display
				System.out.println("data i: "+i + ", idinv: "+idinv+", valueinv: "+valueinv);
				
			}
			
		} catch (Exception e) {
			e.printStackTrace();
			throw e;
		} finally {
			if (dis != null) dis.close();
			if (conn != null) conn.close();
		}
	}

    public static void uploadData(Hashtable h) throws Exception {
		 		
		try {

			String url = persistenceUrl + "?type=update";
			conn = (HttpConnection)Connector.open(url, Connector.READ_WRITE, true);
			conn.setRequestMethod(HttpConnection.POST);
		    conn.setRequestProperty("Content-Type", "application/octet-stream");
			dos = conn.openDataOutputStream();
			CustomTypes.encodeData(h, dos);
		    dos.close();

			// close connexion
			conn.connect();

		} catch (Exception e) {
			e.printStackTrace();
			throw e;
		} finally {
			if (conn != null)
				conn.close();
		}		
	}
	
}
